44034e7df8c030965c642cbc52f713999d6b7f43
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Fre Apr 13 12:49:52 CEST 2007 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
214           CONSOLEFONT='Uni3-Terminus16'
215        else
216           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
217        fi
218     fi
219  fi
220
221  # export it now, so error messages get translated, too
222  if checkgrmlsmall ; then
223     export LANG='C' # grml-small does not provide any further locales
224  else
225     [ -r /etc/default/locale ] && . /etc/default/locale
226     export LANG LANGUAGE
227  fi
228
229  # configure keyboard layout, read in already set values first:
230  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
231
232  # now allow keyboard override by boot commandline for later use:
233  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
234  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
235  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
236  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
237  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
238
239  # modify /etc/sysconfig/keyboard only in live-cd mode:
240  if [ -z "$INSTALLED" ] ; then
241
242    local LANGUAGE="$BOOT_LANGUAGE"
243    . /etc/grml/language-functions
244    # allow setting xkeyboard explicitly different than console keyboard
245    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
246    if [ -n "$KXKEYBOARD" ]; then
247       XKEYBOARD="$KXKEYBOARD"
248       KDEKEYBOARD="$KXKEYBOARD"
249    elif [ -n "$KKEYBOARD" ]; then
250       XKEYBOARD="$KKEYBOARD"
251       KDEKEYBOARD="$KKEYBOARD"
252    fi
253
254    # duplicate of previous code to make sure /etc/grml/language-functions
255    # does not overwrite our values....
256    # now allow keyboard override by boot commandline for later use:
257    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
258    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
259    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
260    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
261    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
262
263    # write keyboard related variables to file for later use
264    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
265    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
266    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
267    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
268    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
269  fi
270
271  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
272
273  # activate unicode console if running within utf8 environment
274  if [ -r /etc/default/locale ] ; then
275     if grep -q "LANG=.*UTF" /etc/default/locale ; then
276        if checkgrmlsmall && [ -z "$INSTALLED" ] ; then
277           ewarn "Not runnning unicode_start: grml-small with reduced language support detected." ; eend 0
278        else
279           einfo "Setting up unicode environment."
280           unicode_start ; eend $?
281        fi
282     fi
283  fi
284
285  # Set default keyboard before interactive setup
286  if [ -n "$KEYTABLE" ] ; then
287   einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
288   loadkeys -q $KEYTABLE &
289   eend $?
290  fi
291
292  # we have to set up all consoles, therefore loop it over all ttys:
293  NUM_CONSOLES=`fgconsole --next-available`
294  NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
295  [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
296  if [ -n "$CHARMAP" ] ; then
297     einfo "Running consolechars for ${CHARMAP}"
298     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
299         consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
300     done
301     eend $RC
302  fi
303  if [ -n "$CONSOLEFONT" ] ; then
304     einfo "Running consolechars using ${CONSOLEFONT}"
305     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
306         consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT || consolechars --tty=/dev/tty${vc} -d
307     done
308     eend $?
309  fi
310
311  eoutdent
312 }
313 # }}}
314
315 # {{{ Set hostname
316 config_hostname(){
317  if checkbootparam hostname ; then
318   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
319   einfo "Setting hostname to $HOSTNAME as requested."
320   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
321   hostname $HOSTNAME ; eend $?
322  else
323   hostname --file /etc/hostname
324  fi
325 }
326 # }}}
327
328 # fstabuser (needed when running from harddisk with username != grml {{{
329 config_userfstab(){
330   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
331   if [ -n "$CONFIG_FSTAB_USER" ] ; then
332      fstabuser="$CONFIG_FSTAB_USER"
333   else
334      fstabuser=$(getent passwd 1000 | cut -d: -f1)
335   fi
336   # if not yet set fall back to default 'grml' user
337   [ -n "$fstabuser" ] || fstabuser='grml'
338 }
339 # }}}
340
341 # {{{ Set clock (Local time is more often used than GMT, so it is default)
342 config_time(){
343  # don't touch the files if running from harddisk:
344  if [ -z "$INSTALLED" ]; then
345     UTC=""
346     checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
347     checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
348     # hwclock uses the TZ variable
349     [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
350     [ -n "$TZ" ] || TZ=Europe/Vienna
351
352     if ! [ -r /dev/rtc ] ; then
353       ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
354     else
355       ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
356       if [ -n "$ERROR" ] ; then
357          eindent
358          ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
359          if [ -n "$ERROR" ] ; then
360             eerror "Problem running hwclock: $ERROR" ; eend 1
361          fi
362          eoutdent
363       fi
364     fi
365  fi
366 }
367 # }}}
368
369 # {{{ print kernel info
370 config_kernel(){
371   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
372   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
373   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
374   if [ -r /proc/cpuinfo ] ; then
375      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
376        eindent
377        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
378        eoutdent
379      fi
380   fi
381   if [ -d /proc/xen ] ; then
382      eindent
383      einfo 'Running kernel featuring support for Xen detected' ; eend 0
384      eoutdent
385   fi
386 }
387 # }}}
388
389 # {{{ vmware specific stuff
390 config_vmware(){
391 if checkbootparam novmware ; then
392    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
393 else
394    if [ -z "$INSTALLED" ] ; then
395       if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
396               if ! checkbootparam qemu ; then
397             if [ -r /etc/X11/xorg.conf.vmware ] ; then
398                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
399                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
400             fi
401          fi
402       fi
403    fi
404 fi
405 }
406 # }}}
407
408 # {{{ qemu specific stuff
409 config_qemu(){
410 if checkbootparam qemu ; then
411    if [ -r /etc/X11/xorg.conf.example ] ; then
412       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
413       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
414    fi
415 fi
416 }
417 # }}}
418
419 # {{{ ld.so.cache + depmod
420 config_ld_mod(){
421 if [ -n "$INSTALLED" ]; then
422  if ! [ -r /etc/grml.first.boot ] ; then
423   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
424   eindent
425 # Regenerate ld.so.cache and module dependencies on HD
426     einfo "Running ldconfig" ; ldconfig  ; eend $?
427     einfo "Running depmod"   ; depmod -a ; eend $?
428     touch /etc/grml.first.boot
429     eend 0
430   eoutdent
431  fi
432 fi
433 }
434 # }}}
435
436 # update_progress {{{
437 update_progress(){
438   # be sure we are non-blocking
439   (echo "$1" > /etc/sysconfig/progress) &
440 }
441 # }}}
442
443 # {{{ timezone
444 config_timezone(){
445  # don't touch the files if running from harddisk:
446  if [ -z "$INSTALLED" ]; then
447   einfo "Setting timezone."
448   KTZ="$(getbootparam tz 2>>$DEBUG)"
449   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
450   rm -f /etc/localtime
451   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
452  fi
453 }
454 # }}}
455
456 # small computer / nearly no ram {{{
457 config_small(){
458
459 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
460 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
461 eindent
462
463 if checkbootparam "small"; then
464   einfo "Information: ${RAM} kB of RAM available." ; eend 0
465   einfo "Bootoption small detected. Activating small system."
466   if [ -r /etc/inittab.small ] ; then
467     mv /etc/inittab /etc/inittab.normal
468     mv /etc/inittab.small /etc/inittab
469   else
470     sed -i 's/^9/#&/' /etc/inittab
471     sed -i 's/^10/#&/' /etc/inittab
472     sed -i 's/^11/#&/' /etc/inittab
473     sed -i 's/^12/#&/' /etc/inittab
474   fi
475   /sbin/telinit q ; eend $?
476 else
477   if checkgrmlsmall ; then
478     if [[ $RAM -lt 25000 ]] ; then
479       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
480       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
481       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
482       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
483       /bin/zsh --login
484     else
485       einfo "Information: ${RAM} kB of RAM available." ; eend 0
486     fi
487   else
488     if [[ $RAM -lt 58000 ]] ; then
489       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
490       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
491       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
492       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
493       /bin/zsh --login
494     else
495       einfo "Information: ${RAM} kB of RAM available." ; eend 0
496     fi
497   fi
498 fi
499 eoutdent
500 }
501 # }}}
502
503 # skip startup of w3m {{{
504 config_fast(){
505 if checkbootparam "fast"; then
506   ewarn "Bootoption fast detected. Skipping startup of w3m."
507     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
508   /sbin/telinit q ; eend $?
509 fi
510 }
511 # }}}
512
513 # activate serial console {{{
514 config_console(){
515 if checkbootparam "console"; then
516   einfo "Bootoption (for serial) console detected."
517   eindent
518     if [ -r /etc/mgetty/mgetty.config ] ; then
519        MODE=$(getbootparam console | awk -F, '{print $2}')
520        MODE=${MODE%%n*}
521        [ -n "$MODE" ] || MODE=9600 # default mode
522        einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
523        sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
524     fi
525
526     einfo "Activating mgetty."
527     sed -i 's/^#T0/T0/' /etc/inittab
528     sed -i 's/^#T1/T1/' /etc/inittab
529     /sbin/telinit q ; eend $?
530   eoutdent
531 fi
532 }
533 # }}}
534
535 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
536 config_cdrom_perm(){
537 CDROMS=""
538 for DEVICE in /proc/ide/hd?; do
539  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
540 done
541 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
542 }
543 # }}}
544
545 # {{{ Bring up loopback interface now
546 config_local_net(){
547  if [ -z "$INSTALLED" ] ; then
548     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
549        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
550     else
551        ifconfig lo up
552     fi
553  fi
554 }
555 # }}}
556
557 # firewire devices {{{
558 # the raw1394 driver does not yet export info into SYSFS,
559 # so let's create raw1394 device manually
560 # http://www.michael-prokop.at/blog/index.php?p=352
561 config_firewire_dev(){
562 if checkbootparam "nofirewiredev" ; then
563   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
564 else
565 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
566   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
567 #  cd /dev && MAKEDEV video1394 raw1394
568   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
569   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
570 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
571   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
572   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
573   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
574 fi
575 #fi
576 }
577 # }}}
578
579 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
580 # otherwise we will get: passwd: Authentication token lock busy
581 config_fix_passwd(){
582  if [ -z "$INSTALLED" ] ; then
583   touch /etc/.pwd.lock
584  fi
585 }
586 # }}}
587
588 # {{{ CD Checker
589 config_testcd(){
590 if [ -n "$TESTCD" ]; then
591   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
592   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
593   echo -n "${RED}"
594   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
595   if [ "$?" = "0" ]; then
596     echo " ${GREEN}Everything looks OK${NORMAL}"
597     else
598     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
599     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
600     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
601     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
602     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
603     read a
604   fi
605   eend 0
606 fi
607 }
608 # }}}
609
610 # {{{ hardware detection via discover
611 config_discover(){
612 if checkbootparam "nodisc" ; then
613   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
614 else
615  if [ -x /sbin/discover ] ; then
616   einfo "Discovering hardware. Trying to load the following modules in background:"
617    eindent
618    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
619    eoutdent
620   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
621   eend 0
622  else
623   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
624  fi
625 fi
626 }
627 # }}}
628
629 # {{{ hardware detection via hwinfo
630 config_hwinfo(){
631 if checkbootparam hwinfo >>$DEBUG 2>&1; then
632   einfo "Discovering hardware via hwinfo:"
633   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
634   echo -n "  Loading modules: "
635   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
636   eend 0
637 fi
638 }
639 # }}}
640
641 # {{{ disable hotplug agents on request
642 config_hotplug_agent(){
643 if checkbootparam "noagent" ; then
644   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
645   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
646   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
647   einfo "Disabling hotplug-agent(s) $AGENTNL"
648   for agent in $(echo -e $AGENTLIST) ; do
649     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
650   done
651   [ "$?" == "0" ] ; eend $?
652 fi
653 }
654 # }}}
655
656 # {{{ blacklist of hotplug-modules
657 config_hotplug_blacklist(){
658 if checkbootparam "black" ; then
659   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
660   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
661   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
662   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
663   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
664   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
665   eend 0
666 fi
667 }
668 # }}}
669
670 # {{{ run hotplug
671 config_hotplug(){
672 if checkbootparam "nohotplug" ; then
673   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
674 else
675   if [ -r /etc/init.d/hotplug ] ; then
676     einfo "Starting hotplug system in background."
677     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
678     eend 0
679   elif [ -r /etc/init.d/hotplug-light ] ; then
680     einfo "Starting hotplug-light system in background."
681     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
682     eend 0
683   else
684     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
685   fi
686 fi
687 }
688 # }}}
689
690 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
691 config_blacklist(){
692 if checkbootparam "blacklist" ; then
693  if [ -z "$INSTALLED" ]; then
694   einfo "Bootoption blacklist found."
695   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
696   if [ -n "$BLACK" ] ; then
697     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
698     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
699     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
700     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
701     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
702   else
703    eerror "No given module for blacklist found. Blacklisting will not work therefor."
704   fi
705  else
706   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
707   eindent
708    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
709   eoutdent
710  fi
711 fi
712 }
713 # }}}
714
715 # {{{ ACPI
716 config_acpi_apm(){
717 if [ -d /proc/acpi ]; then
718   if checkbootparam "noacpi"; then
719     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
720   else
721     einfo "ACPI Bios found, activating modules: "
722     eindent
723     found=""
724     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
725       basename="${a##*/}"
726       basename="${basename%%.*}"
727       case "$basename" in *_acpi)
728        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
729       esac
730       modprobe $basename >>$DEBUG 2>&1 && found="yes"
731       local BASE="$BASE $basename"
732     done
733     if [ -n "$found" ] ; then
734       einfo "$BASE"  ; eend 0
735     else
736       ewarn "(none)" ; eend 1
737     fi
738     if ! [ -S /var/run/acpid.socket ] ; then
739       if ! [ -r /var/run/dbus/pid ] ; then
740         einfo "Starting acpi daemon."
741         /etc/init.d/acpid start >>$DEBUG ; eend $?
742       else
743         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
744         eerror "Solution: please activate acpid via /etc/runlevel.conf"
745         eend 1
746       fi
747     else
748       ewarn "acpi daemon already running."
749       eend 0
750     fi
751     eoutdent
752   fi
753 else
754 # APM
755   if checkbootparam "noapm"; then
756     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
757   else
758     modprobe apm power_off=1 >>$DEBUG 2>&1
759     if [ "$?" = "0" ] ; then
760        if [ -x /etc/init.d/apmd ] ;then
761           einfo "APM Bios found, enabling power management functions."
762           /etc/init.d/apmd start ; eend $?
763        fi
764     else
765       eerror "Loading apm module failed." ; eend 1
766     fi
767   fi
768 fi
769 }
770 # }}}
771
772 # {{{ PCMCIA Check/Setup
773 # This needs to be done before other modules are being loaded (by hwsetup)
774 config_pcmcia(){
775 if checkbootparam "nopcmcia"; then
776   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
777 else
778   if /usr/sbin/laptop-detect ; then
779     einfo "Detected Laptop - checking for PCMCIA." && eend 0
780     modprobe pcmcia_core >>$DEBUG 2>&1
781     # Try Cardbus or normal PCMCIA socket drivers
782     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
783     if [ "$?" = "0" ]; then
784       modprobe ds >>$DEBUG 2>&1
785       if [ -d /proc/bus/pccard ] ; then
786        if [ -x /sbin/cardmgr ] ; then
787         einfo "PCMCIA found, starting cardmgr."
788         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
789        else
790         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
791        fi
792       fi
793     fi
794   fi
795 fi
796 }
797 # }}}
798
799 # {{{ run software synthesizer via speakup
800 config_swspeak(){
801 if checkbootparam swspeak ; then
802  if [ -d /proc/speakup/ ] ; then
803   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
804   eindent
805    if [ -x /etc/init.d/speech-dispatcher ] ; then
806      einfo "Starting speech-dispatcher."
807      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
808      einfo "Activating sftsyn in Kernel."
809      echo sftsyn >/proc/speakup/synth_name ; eend $?
810      einfo "Just run swspeak if you want to use software synthesizer via speakup."
811      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
812    else
813     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
814     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
815    fi
816   eoutdent
817  else
818   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
819   flite -o play -t "Kernel does not seem to support speakup. Sorry."
820  fi
821 fi
822 }
823 # }}}
824
825 # {{{ Check for blind option or brltty
826 config_blind(){
827 BLIND=""
828 checkbootparam "blind" && BLIND="yes"
829 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
830
831 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
832   if [ -x /sbin/brltty ]; then
833     # Blind option detected, start brltty now.
834     # modprobe serial_core parport_serial generic_serial && echo "done"
835     CMD=brltty
836     BRLTYPE=""
837     BRLDEV=""
838     BRLTEXT=""
839     if [ -n "$BRLTTY" ]; then
840       # Extra options
841       BRLTYPE="${BRLTTY%%,*}"
842       R="${BRLTTY#*,}"
843       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
844         BRLTTY="$R"
845         BRLDEV="${BRLTTY%%,*}"
846         R="${BRLTTY#*,}"
847         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
848           BRLTTY="$R"
849           BRLTEXT="${BRLTTY%%,*}"
850           R="${BRLTTY#*,}"
851         fi
852       fi
853     fi
854     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
855     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
856     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
857     einfo "Starting braille-display manager."
858 #    ( exec $CMD & )
859     ( sh -c "$CMD" & )
860     sleep 2 && BLINDSOUND="yes"
861     eend 0
862   fi
863 fi
864 }
865 # }}}
866
867 # {{{ Interactive configuration
868 config_interactive(){
869 if [ -n "$INTERACTIVE" ] ; then
870 einfo "Entering interactive configuration second stage."
871
872   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
873   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
874   read a
875   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
876
877   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
878   read a
879   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
880
881   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
882   read a
883   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
884   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
885 fi
886 eend 0
887 }
888 # }}}
889
890 # {{{ AGP
891 config_agp(){
892 if checkbootparam forceagp ; then
893 # Probe for AGP. Hope this can fail safely
894   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
895 fi
896 }
897 # }}}
898
899 # {{{ automount(er)
900 config_automounter(){
901 if checkbootparam automounter ; then
902   RUNLEVEL="$(runlevel)"
903   AUTOMOUNTER=""
904   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
905
906 addautomount(){
907 # /dev/ice  options
908   d="${1##*/}"
909   if [ -n "$AUTOMOUNTER" ]; then
910     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
911     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
912     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
913     anew="$d        -fstype=auto,$2 :$i"
914     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
915     AUTOMOUNTS="$AUTOMOUNTS $d"
916     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
917   else
918     [ -d /mnt/$d ] && mkdir -p /mnt/$d
919     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
920   fi
921   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
922 }
923
924   AUTOMOUNTS="floppy cdrom"
925 # Add new devices to /etc/fstab and /etc/auto.mnt
926   for i in /dev/cdrom?*; do
927     if [ -L $i ]; then
928       addautomount "$i" "ro"
929     fi
930   done
931 fi
932
933 if [ -n "$AUTOMOUNTER" ]; then
934 # Check for floppy dir, reinstall with automounter
935   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
936   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
937   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
938   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
939   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
940   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
941   rm -f /etc/fstab.new
942 # Replace paths from bootfloppy
943   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
944   mv -f /etc/fstab.new /etc/fstab
945 # Start automounter now
946   einfo "Starting automounter for ${AUTOMOUNTS}."
947   /etc/init.d/autofs start >>$DEBUG ; eend $?
948 fi
949 }
950 # }}}
951
952 # {{{ Collect partitions from /proc/partitions first for enabling DMA
953 check_partitions(){
954 partitions=""
955 IDEDISKS=""
956 while read major minor blocks partition relax; do
957   partition="${partition##*/}"
958   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
959   case "$partition" in
960     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
961     sd?) ;;                                               # SCSI Harddisk, entire disk
962 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
963     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
964   esac
965 done <<EOT
966 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
967 EOT
968 }
969 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
970 # }}}
971
972 # {{{ Enable DMA for all IDE drives now if not disabled
973 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
974 config_dma(){
975 if checkbootparam "nodma"; then
976   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
977 else
978   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
979     if test -d /proc/ide/$d; then
980       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
981         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
982         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
983         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
984         echo "using_dma:1" >/proc/ide/$d/settings
985         eend 0
986       fi
987     fi
988   done
989 fi
990 }
991 # }}}
992
993 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
994 config_fstab(){
995
996 NOSWAP="yes" # we do not use swap by default!
997 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
998    NOSWAP=''
999 fi
1000
1001 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
1002   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1003 else
1004   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
1005   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1006   iszsh && setopt nonomatch
1007   if [ -x /usr/sbin/rebuildfstab ] ; then
1008     config_userfstab || fstabuser=grml
1009     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1010   else
1011     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1012   fi
1013   if [ -e /var/run/rebuildfstab.pid ]; then
1014     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
1015     sleep 8
1016   fi
1017 fi
1018 # Scan for swap, config, homedir
1019 if [ -z "$NOSWAP" ]; then
1020    einfo "Searching for swap partition(s) as requested."
1021 fi
1022 GRML_IMG=""
1023 GRML_SWP=""
1024 HOMEDIR="$(getbootparam home)"
1025 if [ -n "$partitions" ]; then
1026  while read p m f relax; do
1027   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1028   partoptions="users,exec"
1029   fnew=""
1030   case "$f" in swap)
1031    eindent
1032    if [ -n "$NOSWAP" ]; then
1033       if [ -z "$INSTALLED" ] ; then
1034          ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
1035       fi
1036    else
1037      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1038              S1SUSP|S2SUSP|pmdisk|[zZ]*)
1039                 if [ -n "$ANYSWAP" ] ; then
1040                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1041                   swapon $p 2>>$DEBUG ; eend $?
1042                 else
1043                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1044                 fi
1045                ;;
1046              *)
1047                 if [[ "$p" == LABEL* ]] ; then
1048                    p=$(blkid -t $p | awk -F: '{print $1}')
1049                 fi
1050                 if grep -q $p /proc/swaps ; then
1051                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1052                 else
1053                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1054                    swapon $p 2>>$DEBUG ; eend $?
1055                 fi
1056                ;;
1057      esac
1058    fi
1059    eoutdent
1060    continue
1061    ;;
1062   esac
1063 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
1064 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
1065 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
1066 #  [ -d "$m" ] || mkdir -p "$m"
1067 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1068   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1069   MOUNTOPTS="ro"
1070   case "$f" in
1071     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1072     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1073     *) continue ;;
1074     # *) NONEFOUND='1'; continue ;;
1075   esac
1076   if [ -z "$NOSWAP" ] ; then
1077      mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1078      # Activate swapfile, if exists
1079      SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1080   fi
1081   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1082    mount -o remount,rw $m
1083    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1084     einfo "Using GRML swapfile ${SWAPFILE}."
1085     fnew="$SWAPFILE swap swap defaults 0 0"
1086     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1087     GRML_SWP="$GRML_SWP $SWAPFILE"
1088     eend 0
1089    fi
1090    mount -o remount,ro $m 2>>$DEBUG
1091   fi
1092   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1093   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1094    if [ -n "$HOMEDIR" ]; then
1095     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1096      continue
1097     fi
1098    fi
1099    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1100     GRML_IMG="$IMAGE"
1101     mount -o remount,ro $m 2>>$DEBUG
1102    fi
1103   fi
1104   eend 0
1105   # Umount, if not in use
1106   umount -r $m 2>/dev/null
1107  done <<EOT
1108 $(cat /etc/fstab)
1109 EOT
1110 fi
1111 }
1112 # }}}
1113
1114 # {{{ Mouse
1115 config_mouse(){
1116 if [ -n "$MOUSE_DEVICE" ] ; then
1117   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1118 fi
1119 }
1120 # }}}
1121
1122 # {{{ IPv6 configuration
1123 # Load IPv6 kernel module and print IP adresses
1124 config_ipv6(){
1125 if checkbootparam "ipv6"; then
1126   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1127   modprobe ipv6
1128   # we probably need some time until stateless autoconfiguration has happened
1129   sleep 2
1130   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1131   for DEVICE in `echo "$NETDEVICES"`; do
1132     eindent
1133       einfo "$DEVICE:"
1134       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1135       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1136       eindent
1137         for ADDR in `echo "$ADDRESSES"` ; do
1138             einfo "$ADDR"
1139         done
1140         if [ "$COUNT" -eq "0" ] ; then
1141            einfo "(none)" ; eend 1
1142         fi
1143       eoutdent
1144     eoutdent
1145   done
1146   eend 0
1147 fi
1148 }
1149 # }}}
1150
1151 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1152 config_dhcp(){
1153 if checkbootparam "nodhcp"; then
1154   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1155 else
1156   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1157   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1158   for DEVICE in `echo "$NETDEVICES"` ; do
1159     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1160     trap 2 3 11
1161     ifconfig $DEVICE up >>$DEBUG 2>&1
1162     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1163     trap "" 2 3 11
1164     sleep 1
1165     eend 0
1166   done
1167 fi
1168 }
1169 # }}}
1170
1171 # {{{ helper functions
1172 findfile(){
1173 FOUND=""
1174 # search all partitions for a file in the root directory
1175 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1176 # See if it's already mounted
1177   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1178   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1179     [ -f "$i/$1" ] && FOUND="$i/$1"
1180     umount -l "$i" 2>>$DEBUG
1181     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1182   fi
1183 done
1184 return 2
1185 }
1186
1187 fstype(){
1188 case "$(file -s $1)" in
1189   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1190   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1191   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1192   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1193   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1194   *data*)          echo "invalid"; return 0;;
1195   *) echo "auto"; return 0;;
1196 esac
1197 }
1198
1199 # Try to mount this filesystem read-only, without or with encryption
1200 trymount(){
1201 # Check if already mounted
1202 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1203 # Apparently, mount-aes DOES autodetect AES loopback files.
1204 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1205 # We need to mount crypto-loop files with initial rw support
1206 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1207 # Mount succeeded?
1208 [ "$RC" = "0" ] && return 0
1209 echo ""
1210 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1211 a="y"
1212 while [ "$a" != "n" -a "$a" != "N" ]; do
1213 # We need to mount crypto-loop files with initial rw support
1214  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1215  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1216  # Problem with ioctl() from getpasswd()?
1217  # read a
1218  read a
1219 done
1220 return 1
1221 }
1222 # }}}
1223
1224 # {{{ CPU-detection
1225 config_cpu(){
1226 if checkbootparam "nocpu"; then
1227   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1228 else
1229   # check module dependencies
1230   cpufreq_check() {
1231    if [ -e /lib64 ] ; then
1232       [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1233    else
1234       [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1235    fi
1236   }
1237
1238   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1239      einfo "Detecting CPU:"
1240      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1241      echo $CPU | sed 's/ \{1,\}/ /g'
1242      eend 0
1243   else
1244      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1245   fi
1246
1247   if ! cpufreq_check ; then
1248     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1249   else
1250     if /usr/sbin/laptop-detect ; then
1251        einfo "Detected Laptop - trying to use cpu frequency scaling:"
1252        if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1253           eindent
1254           . /usr/bin/cpufreq-detect.sh
1255           if [ -n "$MODULE" -a "$MODULE" != none ]; then
1256              einfo "Loading modules ${MODULE} and cpufreq_ondemand, setting ondemand governor"
1257              modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1258              if modprobe cpufreq_ondemand && RC=0 || RC=1 ; then
1259                 for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1260                     echo ondemand > $file
1261                 done
1262              fi
1263              eend $RC
1264           else
1265              ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
1266           fi
1267           eoutdent
1268        fi # cpufreq-detect
1269     fi # laptop-detect
1270   fi # cpufreq_check
1271 fi # checkbootparam nocpu
1272 }
1273 # }}}
1274
1275 # {{{ autostart of ssh
1276 config_ssh(){
1277 if checkbootparam ssh ; then
1278   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1279   einfo "Bootoption passwd found."
1280   if [ -n "$SSH_PASSWD" ] ; then
1281     echo "grml:$SSH_PASSWD" | chpasswd -m
1282     einfo "Starting secure shell server in background."
1283     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1284     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1285     eend 0
1286   else
1287     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1288   fi
1289   eindent
1290     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1291   eoutdent
1292 fi
1293 }
1294 # }}}
1295
1296 # {{{ set password for user grml
1297 config_passwd(){
1298 if checkbootparam passwd >>$DEBUG 2>&1; then
1299   einfo "Bootoption passwd found."
1300   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1301   if [ -n "$PASSWD" ] ; then
1302     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1303   else
1304     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1305   fi
1306   eindent
1307     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1308   eoutdent
1309 fi
1310 }
1311 # }}}
1312
1313 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1314 config_homedir(){
1315 if checkbootparam home ; then
1316 HOMEDIR="$(getbootparam home)"
1317 MYHOMEDEVICE=""
1318 MYHOMEMOUNTPOINT=""
1319 MYHOMEDIR=""
1320 if [ -n "$HOMEDIR" ]; then
1321   einfo "Bootoption home detected." && eend 0
1322   case "$HOMEDIR" in
1323     /dev/*)
1324     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1325     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1326     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1327     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1328   ;;
1329     /mnt/*)
1330     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1331     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1332     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1333     MYHOMEDIR="$HOMEDIR"
1334   ;;
1335     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1336     MYHOMEDIR="$(findfile grml.img)"
1337     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1338     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1339     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1340   ;;
1341   *)
1342     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1343     eerror "Option ignored." ; eend 1
1344   ;;
1345   esac
1346 fi
1347
1348 if [ -n "$MYHOMEDIR" ]; then
1349   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1350     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1351     while read device mountpoint fs relax; do
1352       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1353         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1354           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1355           break
1356         ;;
1357         *[Ff][Aa][Tt]*)
1358         # Note: This currently won't work with encrypted partitions
1359         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1360         if [ ! -f "$MYHOMEDIR" ]; then
1361           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1362           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1363         fi
1364         ;;
1365       esac
1366       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1367         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1368         if [ -f "$MYHOMEDIR" ]; then
1369           # It's a loopback file, mount it over the /home/grml directory
1370           trymount "$MYHOMEDIR" /home/grml
1371           RC="$?"
1372           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1373           RC="$?"
1374         else
1375           # Do a --bind mount
1376           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1377           RC="$?"
1378         fi
1379         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1380       fi
1381       break
1382       ;;
1383     esac
1384   done <<EOT
1385 $(cat /proc/mounts)
1386 EOT
1387   fi
1388 fi
1389 fi # checkbootparam home
1390 }
1391 # }}}
1392
1393 # {{{ Check for scripts on CD-ROM
1394 config_cdrom_scripts(){
1395 if checkbootparam "script"; then
1396   for script in /cdrom/scripts/* ; do
1397     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1398     . $script
1399   done
1400 fi
1401 }
1402 # }}}
1403
1404 # {{{ Sound
1405 config_mixer(){
1406 if ! [ -x /usr/bin/aumix ] ; then
1407   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1408 else
1409
1410   if checkbootparam vol ; then
1411     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1412     if [ -z "$VOL" ] ; then
1413       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1414       VOL='75' # default
1415     fi
1416   else
1417     VOL='75' # default
1418   fi
1419
1420   if checkbootparam nosound ; then
1421     einfo "Muting sound devices on request."
1422     # some IBM notebooks require the following stuff:
1423     if [ -x /usr/bin/amixer ] ; then
1424        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1425           amixer set Front unmute 1>/dev/null
1426           amixer set Front 0% 1>/dev/null
1427        fi
1428     fi
1429     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1430     if [ -n "$ERROR" ] ; then
1431        eindent
1432        eerror "Problem muting sound devices: $ERROR"
1433        eoutdent
1434     fi
1435     eend $RC
1436   elif [ -z "$INSTALLED" ]; then
1437       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1438       # some IBM notebooks require the following stuff:
1439       if [ -x /usr/bin/amixer ] ; then
1440          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1441             amixer set Front unmute 1>/dev/null
1442             amixer set Front ${VOL}% 1>/dev/null
1443          fi
1444       fi
1445       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1446       if [ -n "$ERROR" ] ; then
1447          eindent
1448          eerror "Problem setting mixer volumes: $ERROR"
1449          eoutdent
1450       fi
1451       eend $RC
1452   fi
1453
1454 fi
1455 }
1456 # }}}
1457
1458 # {{{ modem detection
1459 config_modem(){
1460 if checkbootparam "nomodem"; then
1461   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1462 else
1463   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1464    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1465      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1466      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1467      eend 0
1468    fi
1469   fi
1470 fi
1471 }
1472 # }}}
1473
1474 # {{{ keyboard add-ons
1475 config_setkeycodes(){
1476 if checkbootparam "setkeycodes" ; then
1477  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1478   # MS MM keyboard add-on
1479   # fix
1480   setkeycodes e001 126 &>/dev/null
1481   setkeycodes e059 127 &>/dev/null
1482   # fn keys
1483   setkeycodes e03b 59 &>/dev/null
1484   setkeycodes e008 60 &>/dev/null
1485   setkeycodes e007 61 &>/dev/null
1486   setkeycodes e03e 62 &>/dev/null
1487   setkeycodes e03f 63 &>/dev/null
1488   setkeycodes e040 64 &>/dev/null
1489   setkeycodes e041 65 &>/dev/null
1490   setkeycodes e042 66 &>/dev/null
1491   setkeycodes e043 67 &>/dev/null
1492   setkeycodes e023 68 &>/dev/null
1493   setkeycodes e057 87 &>/dev/null
1494   setkeycodes e058 88 &>/dev/null
1495   # hp keycodes
1496   setkeycodes e00a 89 e008 90 &>/dev/null
1497  eend 0
1498 fi
1499 }
1500 # }}}
1501
1502 # {{{ wondershaper
1503 config_wondershaper(){
1504  if checkbootparam "wondershaper" ; then
1505     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1506     CMD=wondershaper
1507     DEVICE=""
1508     DOWNSTREAM=""
1509     UPSTREAM=""
1510     if [ -n "$WONDER" ]; then
1511       # Extra options
1512       DEVICE="${WONDER%%,*}"
1513       R="${WONDER#*,}"
1514       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1515         WONDER="$R"
1516         DOWNSTREAM="${WONDER%%,*}"
1517         R="${WONDER#*,}"
1518         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1519           WONDER="$R"
1520           UPSTREAM="${WONDER%%,*}"
1521           R="${WONDER#*,}"
1522         fi
1523       fi
1524     fi
1525     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1526     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1527     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1528     einfo "Starting wondershaper (${CMD}) in background."
1529     ( sh -c $CMD & ) && eend 0
1530  fi
1531 }
1532 # }}}
1533
1534 # {{{ syslog-ng
1535 config_syslog(){
1536  if checkbootparam "nosyslog"; then
1537   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1538  else
1539   einfo "Starting syslog-ng in background."
1540   /etc/init.d/syslog-ng start 1>>$DEBUG &
1541   eend 0
1542  fi
1543 }
1544 # }}}
1545
1546 # {{{ gpm
1547 config_gpm(){
1548  if checkbootparam "nogpm"; then
1549   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1550  else
1551   einfo "Starting gpm in background."
1552 #  /etc/init.d/gpm start 1>>$DEBUG &
1553   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1554   eend 0
1555  fi
1556 }
1557 # }}}
1558
1559 # {{{ services
1560 config_services(){
1561  if checkbootparam "services" ; then
1562     SERVICE="$(getbootparam services 2>>$DEBUG)"
1563     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1564     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1565     einfo "Starting service(s) ${SERVICENL} in background."
1566     for service in $(echo -e $SERVICELIST) ; do
1567        /etc/init.d/${service} start 1>>$DEBUG &
1568     done
1569     [ "$?" == "0" ] ; eend $?
1570  fi
1571 }
1572 # }}}
1573
1574 # {{{ config files
1575 config_netconfig(){
1576  if checkbootparam netconfig ; then
1577   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1578   CONFIGFILE='/tmp/netconfig.grml'
1579
1580   getconfig() {
1581   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1582        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1583   }
1584   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1585   counter=10
1586   while ! getconfig && [[ "$counter" != 0 ]] ; do
1587     echo -n "Sleeping for 5 seconds and trying to get config again... "
1588     counter=$(( counter-1 ))
1589     echo "$counter tries left" ; sleep 1
1590   done
1591   if [ -r "$CONFIGFILE" ] ; then
1592     einfo "Downloading was successfull." ; eend 0
1593     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1594     md5sum $CONFIGFILE ; eend 0
1595     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1596   else
1597     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1598   fi
1599  fi
1600 }
1601 # }}}
1602
1603 # {{{ blindsound
1604 config_blindsound(){
1605  if checkbootparam "blind" ; then
1606     beep
1607     flite -o play -t "welcome to the gremel system"
1608  fi
1609 }
1610 # }}}
1611
1612 # {{{ welcome sound
1613 config_welcome(){
1614  if checkbootparam welcome ; then
1615   flite -o play -t "welcome to the gremel system"
1616  fi
1617 }
1618 # }}}
1619
1620 # {{{ fix/workaround for unionfs
1621 fix_unionfs(){
1622   if [ -z "$INSTALLED" ]; then
1623    touch /var/cache/apt/*cache.bin
1624   fi
1625 }
1626 # }}}
1627
1628 # {{{ create all /mnt-directories
1629 create_mnt_dirs(){
1630   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1631   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1632 }
1633 # }}}
1634
1635 # {{{ start X window system via grml-x
1636 config_x_startup(){
1637 if checkbootparam startx ; then
1638  if [ -x /usr/X11R6/bin/X ] ; then
1639   if [ -z "$INSTALLED" ] ; then
1640    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1641    if [ -z "$WINDOWMANAGER" ] ; then
1642      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1643      WINDOWMANAGER="wm-ng"
1644    else
1645      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1646    fi
1647    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1648    config_userfstab || fstabuser='grml'
1649  cat>|/etc/init.d/xstartup<<EOF
1650 #!/bin/sh
1651 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1652 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1653 EOF
1654    chmod 755 /etc/init.d/xstartup
1655
1656    sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
1657
1658    /sbin/telinit q ; eend $?
1659
1660    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1661       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1662    else
1663       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1664    fi
1665
1666   else
1667     eerror "We are not running from CD - startx will not work, skipping it.
1668      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1669   fi
1670  else
1671    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1672    Boot parameter startx does not work therefore." ; eend 1
1673  fi
1674 fi
1675 }
1676 # }}}
1677
1678 # {{{ configuration framework
1679 config_extract(){
1680 if checkbootparam extract ; then
1681  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1682  EXTRACTOPTIONS="-- -x $EXTRACT"
1683 fi
1684 }
1685
1686 config_automount(){
1687 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1688   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1689 else
1690  if [ -z "$INSTALLED" ] ; then
1691   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1692   eindent
1693   [ -d /mnt/grml ] || mkdir /mnt/grml
1694   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1695 # We do need the following fix so floppy disk is available to blkid in any case :-/
1696   if [ -r /dev/fd0 ] ; then
1697      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1698 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1699      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1700         blkid /dev/fd0 1>>$DEBUG 2>&1
1701      fi
1702   fi
1703   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1704   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1705   if [[ $RC == 0 ]]; then
1706     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1707
1708     CONFIG=''
1709     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1710     if [ -n "$CONFIG" ]; then
1711       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1712       cd /
1713       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1714     else
1715       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1716     fi
1717
1718     SCRIPT=''
1719     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1720     if [ -n "$SCRIPT" ]; then
1721       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1722       $SCRIPT ; eend $?
1723     fi
1724     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1725   else
1726     ewarn "No devices with label GRMLCFG found." ; eend 0
1727   fi
1728   eoutdent
1729  fi
1730 fi
1731 }
1732
1733 config_myconfig(){
1734
1735 if checkbootparam "config" ; then
1736   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1737   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1738   einfo "Bootoption config found. config is set to: $CONFIG"
1739   eindent
1740     einfo "Trying to extract configuration file ${CONFIG}:"
1741     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1742   eoutdent
1743 fi
1744
1745 if checkbootparam myconfig ; then
1746  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1747  if [ -n "$MOUNTDEVICE" ]; then
1748    if checkbootparam file ; then
1749     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1750     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1751    fi
1752    [ -d /mnt/grml ] || mkdir /mnt/grml
1753    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1754    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1755     if [[ $RC == 0 ]]; then
1756       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1757       eindent
1758       CONFIG=''
1759       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1760       if [ -n "$CONFIG" ]; then
1761         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1762         cd /
1763         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1764       else
1765         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1766       fi
1767
1768       SCRIPT=''
1769       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1770       if [ -n "$SCRIPT" ]; then
1771         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1772         $SCRIPT ; eend $?
1773       fi
1774       eoutdent
1775     else
1776       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1777     fi # mount $MOUNTDEVICE
1778    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1779  else
1780    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1781  fi # [ -n "$MOUNTDEVICE" ]
1782 fi # checkbootparam myconfig
1783
1784 if checkbootparam "partconf" ; then
1785  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1786  if [ -n "$MOUNTDEVICE" ]; then
1787    [ -d /mnt/grml ] || mkdir /mnt/grml
1788    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1789     if [[ $RC == 0 ]]; then
1790       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1791       einfo "Copying files from $MOUNTDEVICE over grml system."
1792       for file in `cat /etc/grml/partconf` ; do
1793         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1794         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1795       done && eend 0
1796     else
1797       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1798     fi # mount $MOUNTDEVICE
1799    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1800  else
1801    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1802  fi # [ -n "$MOUNTDEVICE" ]
1803 fi
1804 }
1805 # }}}
1806
1807 # {{{ /cdrom/.*-options
1808 config_debs(){
1809 if checkbootparam "debs" ; then
1810   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1811   einfo "Tring to install debian package(s) ${DEBS}"
1812   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1813 fi
1814 }
1815
1816 config_scripts(){
1817 if checkbootparam "scripts" ; then
1818   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1819   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1820   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1821   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1822 fi
1823 }
1824 # }}}
1825
1826 # {{{ distcc
1827 config_distcc(){
1828 if checkbootparam "distcc" ; then
1829  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1830  if [ -n "$OPTIONS" ]; then
1831     NET=""
1832     INTERFACE=""
1833     if [ -n "$OPTIONS" ]; then
1834       NET="${OPTIONS%%,*}"
1835       R="${OPTIONS#*,}"
1836       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1837         OPTIONS="$R"
1838         INTERFACE="${OPTIONS%%,*}"
1839         R="${OPTIONS#*,}"
1840       fi
1841     fi
1842  fi
1843  CONFIG=/etc/default/distcc
1844  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1845  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1846
1847  if [ -n "$INTERFACE" ] ; then
1848    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1849
1850    counter=10
1851    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1852      counter=$(( counter-1 ))
1853      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1854      sleep 3
1855      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1856    done
1857  fi
1858
1859  if [ -n "$IP" ] ; then
1860    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1861
1862    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1863    eindent
1864     id distccd >/dev/null 2>&1 || \
1865     (
1866       einfo "Creating distcc user" ; \
1867       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1868     )
1869
1870     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1871    /etc/init.d/distcc start 1>/dev/null ; eend $?
1872    eoutdent
1873  else
1874    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1875  fi
1876 fi
1877
1878 if checkbootparam "gcc"; then
1879  GCC="$(getbootparam gcc 2>>$DEBUG)"
1880  eindent
1881  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1882  eoutdent
1883  rm -f /usr/bin/gcc
1884  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1885 fi
1886
1887 if checkbootparam "gpp"; then
1888  GPP="$(getbootparam gpp 2>>$DEBUG)"
1889  eindent
1890   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1891   if [ -x /usr/bin/g++-${GPP} ] ; then
1892      rm -f /usr/bin/g++
1893      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1894   fi
1895   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1896   if [ -x /usr/bin/cpp-${GPP} ] ; then
1897      rm -f /usr/bin/cpp
1898      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1899   fi
1900  eoutdent
1901 fi
1902
1903 }
1904 # }}}
1905
1906 # {{{ load modules
1907 # Notice: use it only on live-cd system, if running from harddisk please
1908 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1909 # in /etc/runlevel.conf
1910 config_modules(){
1911 MODULES_FILE=/etc/grml/modules
1912 if checkbootparam nomodules ; then
1913   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1914 elif [ -z "$INSTALLED" ]; then
1915  if [ -r $MODULES_FILE ] ; then
1916   einfo "Loading modules specified in ${MODULES_FILE}:"
1917   eindent
1918   grep '^[^#]' $MODULES_FILE | \
1919   while read module args; do
1920     [ "$module" ] || continue
1921       einfo "${module}"
1922       modprobe $module $args ; eend $?
1923   done
1924   eoutdent
1925  else
1926   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1927  fi
1928 fi
1929 }
1930 # }}}
1931
1932 # {{{ 915resolution
1933 config_915resolution(){
1934 if checkbootparam "915resolution" ; then
1935  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1936   if [ -x /usr/sbin/915resolution ]; then
1937     CMD=915resolution
1938     MODE=""
1939     XRESO=""
1940     YRESO=""
1941     if [ -n "$OPTIONS" ]; then
1942       # Extra options
1943       MODE="${OPTIONS%%,*}"
1944       R="${OPTIONS#*,}"
1945       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1946         OPTIONS="$R"
1947         XRESO="${OPTIONS%%,*}"
1948         R="${OPTIONS#*,}"
1949         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1950           OPTIONS="$R"
1951           YRESO="${OPTIONS%%,*}"
1952           R="${OPTIONS#*,}"
1953         fi
1954       fi
1955     fi
1956     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1957     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1958     eend 0
1959   fi
1960 fi
1961 }
1962 # }}}
1963
1964 # {{{ SW-RAID
1965 config_swraid(){
1966   if [ -z "$INSTALLED" ] ; then
1967   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1968   if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
1969      checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
1970      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
1971   else
1972     if ! [ -x /sbin/mdadm ] ; then
1973        eerror "mdadm not available, can not execute it." ; eend 1
1974     else
1975
1976        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1977        # find out whether we have a valid configuration file already
1978        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1979           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
1980           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1981           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1982         else
1983           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1984        fi
1985
1986        if ! checkbootparam 'swraid' ; then
1987           eindent
1988           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
1989           eoutdent
1990        else
1991           einfo "Bootoption swraid found. Searching for software RAID arrays:"
1992           eindent
1993            IFSOLD=${IFS:-}
1994            IFS='
1995 '
1996            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1997                case $line in
1998                  *'No arrays found'*)
1999                    ewarn "$line" ; eend 0
2000                    ;;
2001                  *)
2002                    einfo "$line" ; eend 0
2003                    ;;
2004                esac
2005            done
2006            IFS=$IFSOLD
2007          eoutdent
2008
2009          if [ -r /proc/mdstat ] ; then
2010             eindent
2011             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2012             if [ -z "$MDSTAT" ] ; then
2013                ewarn "No active arrays found" ; eend 0
2014             else
2015                IFSOLD=${IFS:-}
2016                IFS='
2017 '
2018                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2019                    einfo "active arrays: $line" ; eend 0
2020                done
2021                IFS=$IFSOLD
2022             fi
2023             eoutdent
2024          fi # /proc/mdstat
2025        fi # bootoption swraid
2026
2027      fi # is /sbin/mdadm executable?
2028   fi # check for bootoptions
2029   fi # run only in live-cd mode
2030 }
2031 # }}}
2032
2033 # {{{ debnet: setup network based on an existing one found on a partition
2034 config_debnet(){
2035 if checkbootparam "debnet" ; then
2036  iszsh && setopt shwordsplit
2037  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2038  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2039  FOUND_DEBNET=""
2040
2041  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2042  eindent
2043  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2044     for i in $DEVICES; do
2045      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2046          einfo "Scanning on $i"
2047        if [ -f /mnt/etc/network/interfaces ]; then
2048          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2049          FOUND_DEBNET="$i"
2050          break
2051        fi
2052        umount /mnt
2053      fi
2054     done
2055
2056    if [ -n "$FOUND_DEBNET" ]; then
2057      einfo "Stopping network."
2058        pump -k 1>/dev/null 2>&1
2059        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2060      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2061        rm -rf /etc/network/run
2062        cp -a /mnt/etc/network /etc
2063        rm -rf /etc/network/run
2064        mkdir /etc/network/run
2065        umount /mnt ; eend $?
2066      einfo "Starting network."
2067        /etc/init.d/networking start ; eend $?
2068    else
2069      eerror "/etc/network/interfaces not found." ; eend 1
2070    fi
2071    eoutdent
2072  else
2073   eerror "Error: /mnt already mounted." ; eend 1
2074  fi
2075 fi
2076 }
2077 # }}}
2078
2079 # {{{ disable console blanking
2080 config_blanking(){
2081 if checkbootparam "noblank" ; then
2082   einfo "Bootoption noblank found. Disabling monitor blanking."
2083   setterm -blank 0 ; eend $?
2084 fi
2085 }
2086 # }}}
2087
2088 # {{{ grml2hd: automatic installation
2089 config_grml2hd(){
2090
2091 if checkbootparam "user" ; then
2092   NEWUSER=''
2093   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2094   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2095 fi
2096
2097 if checkbootparam "filesystem" ; then
2098   FILESYSTEM=''
2099   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2100   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2101 fi
2102
2103 if checkbootparam "partition" ; then
2104   PARTITION=''
2105   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2106   # notice: the following checks whether the given partition is available, if not the skip
2107   # execution of grml2hd as it might result in data loss...
2108   if [ -r $PARTITION ] ; then
2109     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2110   else
2111     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2112   fi
2113 fi
2114
2115 if checkbootparam "mbr" ; then
2116   BOOT_PARTITION=''
2117   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2118   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2119 fi
2120
2121 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2122   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2123 #!/bin/sh
2124 GRML2HD_NONINTERACTIVE='yes' grml2hd
2125 EOF
2126   chmod 755 /usr/bin/grml2hd_noninteractive
2127   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2128   if [ -z "$GRML2HD_FAIL" ] ; then
2129     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2130   else
2131     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2132   fi
2133 fi
2134 }
2135 # }}}
2136
2137 # {{{ Support customization
2138 config_distri(){
2139 if checkbootparam "distri"; then
2140   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2141   if [ -r /cdrom/desktop/"$DISTRI".jpg ] ; then
2142      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file /cdrom/desktop/$DISTRI present" && eend 0
2143      cp /cdrom/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2144   fi
2145 fi
2146 }
2147 # }}}
2148
2149 ### {{{ backwards compatible stuff
2150 config_environment(){
2151   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2152 }
2153 config_keyboard(){
2154   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2155 }
2156 # }}}
2157
2158 ## END OF FILE #################################################################
2159 # vim:foldmethod=marker